<?
/********************************************************************************************************
	Project : XBBS ver.4
	Part : XMySQL
	Segment : XMySQL Class Real ver.4
	FileName : xbbs/lib/xmysql_class_real.php
	
	 : ӿ [017-425-5454]
    ó : xbbs@hotmail.com
     : 2001-12-31
*********************************************************************************************************/
?>
<? 
    global $_XMYSQL_CLASS;
    $_XMYSQL_CLASS = "INCLUDED";
?>
<?
class XMySQL
{
    var $Handle;        /* DB Handle */

    var $HostName;      /* Host Address */
    var $Database;      /* DB Name */
    var $UserID;        /* DB UserID */
    var $Password;      /* DB Password */

    var $Text;           /* Query String */
    var $Result;         /* DB Result */
    var $RecNo;          /* DB Record Number */
    var $RecCnt;         /* DB Record Count */
    var $FieldCnt;       /* DB Field Count */
    var $EOF;            /* DB EOF */


Function XMySQL( $HostName, $Database, $UserID, $Password )
{
    $this->Handle = 0;
    $this->HostName = "";
    $this->UserID = "";
    $this->Database = "";
    $this->Password = "";

    $this->Text = "";
    $this->Result = FALSE;
    $this->RecNo = 0;
    $this->RecCnt = 0;
    $this->FieldCnt = 0;
    $this->EOF = FALSE;

    $this->HostName = $HostName;
    $this->UserID = $UserID;
    $this->Database = $Database;
    $this->Password = $Password;

    $this->Connect();

    return;
}

Function XMySQL_Destructor()
{
    $this->Close();
}

Function Error( $ErrMsg, $ErrCode )
{
    echo "
<html>
    <script language='JavaScript'>
        alert( '$ErrMsg' );
    </script>
</html>
    ";
}

Function GoBackExit()
{
    echo "
<html>
    <script language='JavaScript'>
        history.go(-1);
    </script>
</html>
    ";
}

Function GoBackExit2( $i )
{
    echo "
<html>
    <script language='JavaScript'>
        history.go( $i );
    </script>
</html>
    ";
}

Function CloseExit()
{
    echo "
<html>
    <script language='JavaScript'>
        self.close();
    </script>
</html>
    ";
}

Function Connect()
{
    if(  !( $this->Handle=mySQL_Connect($this->HostName,$this->UserID,$this->Password) )  )
    {
        $this->Error( "Error to DB Connection", "001-010" );
        return FALSE;
    }
    else
    {
        mySQL_Select_DB( $this->Database, $this->Handle );
        return TRUE;
    }
}

Function SetDatabase( $Database )
{
    $this->Database = $Database;
    if( !$this->Handle )
    {
        return( $this->Connect() );
    }
    else
    {
        mySQL_Select_DB( $this->Database, $this->Handle );
        return TRUE;
    }
}

Function Clear()
{
    $this->Text = "";
}

Function Add( $AddText )
{
    $this->Text .= " ".$AddText;
}

Function ExecSQL()
{
    if( !$this->Handle )     $this->Connect();

    $this->Result = mySQL_Query( $this->Text, $this->Handle );
    $this->RecCnt = mySQL_Affected_Rows( $this->Handle );
}

Function ClearResult()
{
    $this->RecNo = 0;
    $this->FieldCnt = 0;
    $this->RecCnt = 0;
    $this->EOF = TRUE;
}

Function Open()
{
    $this->ClearResult();

    if( !$this->Handle )        $this->Connect();

    if( $this->Result > 1 ) mySQL_Free_Result( $this->Result );
    $this->Result = mySQL_Query( $this->Text, $this->Handle );

    if( $this->Result )
    {
        $this->FieldCnt = mySQL_Num_Fields( $this->Result );
        $this->RecCnt = mySQL_Num_Rows( $this->Result );

        if( $this->RecCnt > 0 ) $this->EOF = FALSE;
        else $this->EOF = TRUE;
    }
}

Function FreeResult()
{
    mySQL_Free_Result( $this->Result );
}

Function Close()
{
    if( $this->Handle )
        mySQL_Close( $this->Handle );
}

Function GetFieldName( $FieldID )
{
    return mySQL_Field_Name( $this->Result, $FieldID );
}

Function GetFieldID( $FieldName )
{
    for( $i=1 ; $i <= $this->FieldCnt ; $i++ )
       if( $this->GetFieldName($i) == $FieldName )
            return $i;

    return FALSE;
}

Function GetFieldType( $FieldID )
{
    if( gettype($FieldID) != "integer" )
        return mySQL_Field_Type( $this->Result, $this->GetFieldID($FieldID) );
    else
        return mySQL_Field_Type( $this->Result, $FieldID );
}

Function GetFieldLength( $FieldID )
{
    if( gettype($FieldID) != "integer" )
        return mySQL_Field_Len( $this->Result, $this->GetFieldID($FieldID) );
    else
        return mySQL_Field_Len( $this->Result, $FieldID );
}

Function GetField( $FieldName )
{
    return mySQL_Result( $this->Result, $this->RecNo, $FieldName );
}

Function First()
{
   $this->RecNo = 0;
   $this->EOF = FALSE;
}

Function Prior()
{
   if( $this->RecNo > 0 )
   {
       --$this->RecNo;
       $this->EOF = FALSE;
   }
}

Function Next()
{
   if( $this->RecNo < $this->RecCnt )
   {
       ++$this->RecNo;
       if( $this->RecNo >= $this->RecCnt )
           $this->EOF = TRUE;
   }
}

Function Last()
{
   $this->RecNo = $this->RecCnt - 1;
   $this->EOF = TRUE;
}

Function TableIsExist( $TableName )
{
    if( !$this->Handle ) $this->Connect();

    $Tables = mySQL_List_Tables( $this->Database );
    $TablesRows = mySQL_Num_Rows( $Tables );

    for( $i=0 ; $i < $TablesRows ; $i++ )
    {
        if(  !strcmp( mySQL_Tablename($Tables,$i), $TableName )  )
        {
            mySQL_Free_Result( $Tables );
            return TRUE;
        }
    }

    mySQL_Free_Result( $Tables );
    return FALSE ;
}

Function FieldIsExist( $TableName, $FieldName )
{
    if( !$this->Handle ) $this->Connect();

    $Fields = mySQL_List_Fields( $this->Database, $TableName, $this->Handle );
    $FieldRows = mySQL_Num_Fields( $Fields );

    for( $i=0 ; $i < $FieldRows ; $i++ )
    {
        if(  !strcmp( mySQL_Field_Name($Fields,$i), $FieldName )  )
        {
            mySQL_Free_Result( $Fields );
            return TRUE;
        }
    }
    mySQL_Free_Result( $Fields );
    return FALSE;
}

Function ColumnIsExist( $TableName, $ColumnName )
{
    return( FieldIsExist($TableName,$ColumnName) );
}


Function IsRoot()
{
    global $XBBS_ID, $XBBS_LEVEL;

    if( $this->IsLogin() && $XBBS_LEVEL==1 )
        return TRUE;
    else
        return FALSE;
}


Function IsAdmin()
{
    global $XBBS_ID, $XBBS_LEVEL;

    if( $this->IsRoot() && $XBBS_ID=="admin" )
        return TRUE;
    else
        return FALSE;
}


Function IsLogin()
{
    global $XBBS_ID, $XBBS_LEVEL;

    if( session_is_registered("XBBS_ID") && session_is_registered("XBBS_LEVEL") && strlen($XBBS_ID)>0 && $XBBS_LEVEL>0 )
        return TRUE;
    else
        return FALSE;
}





}

?>
<?  /* End Of xmysql_class.php */   ?>